* PACKAGE DRUNGE    !" ʬ( 4th order Runge-Kutta Scheme )
*
*"  [HIS] 95/08/12 (takepiro) 
*"        95/08/14 (takepiro) 
*"        96/02/05 (takepiro) bug fix
***********************************************************************
      SUBROUTINE DRUNGE
     O             ( PSI3  , ZETA3 , T3  ,
     I               PSI2  , ZETA2 , T2  , 
     I               RAYL  , PRND  , QINT,
     C               DX    , DZ    , DT  ,
     W               PSI   , ZETA  , T   , 
     W               TNDZ  , TNDT  ,
     W               AJAC  , ALAP          )
*
*"      << 4th order Runge-Kutta scheme ˤʬ >>
*"                     95/08/12 (ݹ)
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL PSI3  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(STEP)
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
      REAL T3    ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL PRND                 !" ץȥ
      REAL RAYL                 !" 쥤꡼
      REAL QINT                 !" ǮΨ
*
      REAL DX                   !" X γʻֳ
      REAL DZ                   !" Z γʻֳ
      REAL DT                   !" ֳִ
*
* [WORK]
      REAL PSI  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(ʬ)
      REAL ZETA ( 0:NX+1 , 0:NZ+1 ) !" (ʬ)
      REAL T    ( 0:NX+1 , 0:NZ+1 ) !" (ʬ)
      REAL TNDZ ( 0:NX+1 , 0:NZ+1 ) !"  1 ʳǤα٤λѲ
      REAL TNDT ( 0:NX+1 , 0:NZ+1 ) !"  1 ʳǤβ٤λѲ
      REAL AJAC ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
*  [INTERNAL WORK]
      REAL DELT(3)              !" ʬѻֳִ
      REAL WEIGH(4)             !" ʬѻֳִ
*
      INTEGER IRUNG                !"롼ץ
      INTEGER IX                   !"롼ץ
      INTEGER IZ                   !"롼ץ
*
      LOGICAL OFIRST
      DATA    OFIRST  / .TRUE. /
      SAVE  OFIRST 
*
      IF( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL MSGDMP('M','DRUNGE',
     &               '4TH RUNGE-KUTTA SCHEME : 95/08/14' )
      ENDIF
*
*"         < 0.  >
*
      DELT(1)  =  DT * 0.5
      DELT(2)  =  DT * 0.5
      DELT(3)  =  DT
*
      WEIGH(1)  =       DT / 6.
      WEIGH(2)  =  2. * DT / 6. 
      WEIGH(3)  =  2. * DT / 6. 
      WEIGH(4)  =       DT / 6. 
*
*"             ʬ
      CALL COPY ( PSI3  , PSI2  , (NX+2)*(NZ+2) )
      CALL COPY ( ZETA3 , ZETA2 , (NX+2)*(NZ+2) )
      CALL COPY ( T3    , T2    , (NX+2)*(NZ+2) )
*
*"             ʬ
      CALL COPY ( PSI   , PSI2  , (NX+2)*(NZ+2) )
      CALL COPY ( ZETA  , ZETA2 , (NX+2)*(NZ+2) )
      CALL COPY ( T     , T2    , (NX+2)*(NZ+2) )
*
*"         < 1. ʬ >
*
      DO 1000 IRUNG = 1, 4
         CALL DEULTZ            !" ʬ
     O       ( TNDZ  ,
     I         PSI   , ZETA  , T  , 
     C         RAYL  , PRND  ,
     C         DX    , DZ    , 
     W         AJAC  , ALAP    )
*
         CALL DEULTT            !" ٤μʬ
     O      ( TNDT  , 
     I        PSI   , T   , 
     C        QINT  , 
     C        DX    , DZ  ,
     W        AJAC  , ALAP    )
*
         IF ( IRUNG .LT. 4 ) THEN       !" ʬ
            DO 1100 IZ = 1, NZ 
               DO 1110 IX = 1 , NX
                  ZETA ( IX,IZ ) = ZETA2( IX,IZ )
     &                 + TNDZ ( IX,IZ )* DELT(IRUNG)
                  T    ( IX,IZ ) = T2( IX,IZ )
     &                 + TNDT ( IX,IZ )* DELT(IRUNG)
 1110          CONTINUE 
 1100        CONTINUE 
*
             CALL DBNDR
     O            ( PSI   , 
     M              ZETA  , T   ,
     I              DX    , DZ    )
          ENDIF                         !" ʬޤ
*
          DO 1200 IZ = 1, NZ            !"   ʬ
             DO 1210 IX = 1, NX
                ZETA3( IX,IZ ) = ZETA3( IX,IZ )
     &               + TNDZ ( IX,IZ ) * WEIGH(IRUNG)
                T3   ( IX,IZ ) = T3( IX,IZ )
     &               + TNDT ( IX,IZ ) * WEIGH(IRUNG)
 1210        CONTINUE
 1200     CONTINUE
*
 1000 CONTINUE 
*
*"         < 2.  >
*
      CALL DBNDR
     O      ( PSI3  , 
     M        ZETA3 , T3  ,
     I        DX    , DZ    )
*
      RETURN
      END
